"
 COPYRIGHT (c) 1995 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"


SocketAddress subclass:#IPSocketAddress
	 instanceVariableNames:'port address'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'ST80-Compatibility'
!

!IPSocketAddress class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1995 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

version
    ^ '$Header: /cvs/stx/stx/libbasic2/IPSocketAddress.st,v 1.3 1995-11-11 15:33:34 cg Exp $'
!

documentation
"
    Instances of IPSocketAddress represent tcp/ip-domain socket addresses.
    These consist of an ip address (4 bytes) and a port number.

    ST-80 compatibility class.
    This may be required when existing code has to be ported to ST/X;
    however, it may not be complete and more protocol may be added in the future.
    The code here was created when public domain code (Manchester) had to
    be ported to ST/X and missing classes/methods were encountered, and code added
    by reasoning 'what the original class could probably do there'.

    This is an additional goody class; therefore:

    THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
    ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
    OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
    OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
"
! !

!IPSocketAddress class methodsFor:'queries'!

hostAddressByName: hostName
    ^ Socket ipAddressOfHost:hostName

    "
     IPSocketAddress hostAddressByName:'clam' 
     IPSocketAddress hostAddressByName:'foobar' 
    "
!

hostNameByAddress: anAddress
    ^ Socket hostWithIpAddress:anAddress

    "
     |addr|

     addr := IPSocketAddress hostAddressByName:'porty'.
     IPSocketAddress hostNameByAddress:addr  
    "
! !

!IPSocketAddress class methodsFor:'instance creation'!

hostAddress:addr port:portNr
    ^ self basicNew
	hostAddress:addr port:portNr
! !

!IPSocketAddress methodsFor:'accessing'!

hostAddress:addr port:portNr
    address := addr.
    port := portNr
! !

!IPSocketAddress methodsFor:'queries'!

hostName
    ^ Socket hostWithIpAddress:address

    "Created: 2.11.1995 / 11:17:28 / cg"
!

hostAddress
    ^ address 
!

port
    ^ port
!

portOrName
    ^ port
!

address
    ^ address
! !
